zoukankan      html  css  js  c++  java
  • (程序员面试题精选(03))-求子数组的最大和

        

    求子数组的最大和
    题目:输入一个整形数组,数组里有正数也有负数。数组中连续的一个或多个整数组成一个子数组,每个子数组都有一个和。求所有子数组的和的最大值。要求时间复杂度为O(n)
            例如输入的数组为1, -2, 3, 10, -4, 7, 2, -5,和最大的子数组为3, 10, -4, 7, 2,因此输出为该子数组的和18
            如果不考虑时间复杂度,我们可以枚举出所有子数组并求出他们的和。不过非常遗憾的是,由于长度为n的数组有O(n2),具体是n*(n+1)/2个子数组;而且求一个长度为n的数组的和的时间复杂度为O(n)。因此这种思路的时间是O(n3)
     
    解题思路:很容易理解,当我们加上一个正数时,和会增加;当我们加上一个负数时,和会减少。如果当前得到的和是个负数,那么这个和在接下来的累加中应该抛弃并重新清零,不然的话这个负数将会减少接下来的和。
     
    // MaxSubSumArray.cpp : 定义控制台应用程序的入口点。
    //

    #include 
    "stdafx.h"
    #include 
    "iostream"
    using namespace std;

    bool FindGreatestSumOfSubArray
    (
     
    int *pData,               // an array
     unsigned int nLength, // the length of array
     int &nGreatestSum    // the greatest sum of all sub-arrays
     )
    {
      
    // if the input is invalid, return false
      if((pData == NULL) || (nLength == 0))
        
    return false;
      
    int nCurSum = nGreatestSum = 0;
      
    for(unsigned int i = 0; i < nLength; ++i)
      {
        nCurSum 
    += *pData;
        
    // if the current sum is negative, discard it
        if(nCurSum < 0)
        {
          nCurSum 
    = 0;
        }
    else
        {
          cout
    <<i<<"--"<<*pData<<endl;
        }

        
    // if a greater sum is found, update the greatest sum
        if(nCurSum > nGreatestSum)
          nGreatestSum 
    = nCurSum;
        pData
    ++;
      }
      
    // if all data are negative, find the greatest element in the array
      if(nGreatestSum == 0)
      {
        nGreatestSum 
    = pData[0];
        
    for(unsigned int i = 1; i < nLength; ++i)
        {
          
    if(pData[i] > nGreatestSum)
            nGreatestSum 
    = pData[i];
        }
      }
      cout
    <<nGreatestSum<<endl;
      
    return true;
    }    
    int _tmain(int argc, _TCHAR* argv[])
    {
      
    int arry[]={1,2,-1,3,4,-4,5,-1,10};
      
    int subSum;
      FindGreatestSumOfSubArray(arry, 
    sizeof(arry)/ sizeof(int),subSum);
      
      
    return 0;
    }


    还有其它的解决办法。

    如下

    http://luisliu.blog.51cto.com/883990/227200
     

  • 相关阅读:
    旧题复习{6}
    CF219D. Choosing Capital for Treeland [树形DP]
    POJ1947 Rebuilding Roads[树形背包]

    洛谷P1280 尼克的任务[DP]
    NOIP2003pj栈[卡特兰数]
    NOIP2001统计单词个数[序列DP]
    洛谷P1415 拆分数列[序列DP 状态 打印]
    POJ2828 Buy Tickets[树状数组第k小值 倒序]
    CF380C. Sereja and Brackets[线段树 区间合并]
  • 原文地址:https://www.cnblogs.com/likwo/p/1913752.html
Copyright © 2011-2022 走看看